// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from ublox_ubx_msgs:msg/PSMPVT.idl
// generated code does not contain a copyright notice

#ifndef UBLOX_UBX_MSGS__MSG__DETAIL__PSMPVT__STRUCT_HPP_
#define UBLOX_UBX_MSGS__MSG__DETAIL__PSMPVT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__ublox_ubx_msgs__msg__PSMPVT __attribute__((deprecated))
#else
# define DEPRECATED__ublox_ubx_msgs__msg__PSMPVT __declspec(deprecated)
#endif

namespace ublox_ubx_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct PSMPVT_
{
  using Type = PSMPVT_<ContainerAllocator>;

  explicit PSMPVT_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->state = 0;
    }
  }

  explicit PSMPVT_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->state = 0;
    }
  }

  // field types and members
  using _state_type =
    uint8_t;
  _state_type state;

  // setters for named parameter idiom
  Type & set__state(
    const uint8_t & _arg)
  {
    this->state = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t PSM_STATE_NOT_ACTIVE =
    0u;
  static constexpr uint8_t PSM_STATE_ENABLED =
    1u;
  static constexpr uint8_t PSM_STATE_ACQUISITION =
    2u;
  static constexpr uint8_t PSM_STATE_TRACKING =
    3u;
  static constexpr uint8_t PSM_STATE_POWER_OPTIMIZED_TRACKING =
    4u;
  static constexpr uint8_t PSM_STATE_INACTIVE =
    5u;

  // pointer types
  using RawPtr =
    ublox_ubx_msgs::msg::PSMPVT_<ContainerAllocator> *;
  using ConstRawPtr =
    const ublox_ubx_msgs::msg::PSMPVT_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<ublox_ubx_msgs::msg::PSMPVT_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<ublox_ubx_msgs::msg::PSMPVT_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      ublox_ubx_msgs::msg::PSMPVT_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<ublox_ubx_msgs::msg::PSMPVT_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      ublox_ubx_msgs::msg::PSMPVT_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<ublox_ubx_msgs::msg::PSMPVT_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<ublox_ubx_msgs::msg::PSMPVT_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<ublox_ubx_msgs::msg::PSMPVT_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__ublox_ubx_msgs__msg__PSMPVT
    std::shared_ptr<ublox_ubx_msgs::msg::PSMPVT_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__ublox_ubx_msgs__msg__PSMPVT
    std::shared_ptr<ublox_ubx_msgs::msg::PSMPVT_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PSMPVT_ & other) const
  {
    if (this->state != other.state) {
      return false;
    }
    return true;
  }
  bool operator!=(const PSMPVT_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PSMPVT_

// alias to use template instance with default allocator
using PSMPVT =
  ublox_ubx_msgs::msg::PSMPVT_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
constexpr uint8_t PSMPVT_<ContainerAllocator>::PSM_STATE_NOT_ACTIVE;
template<typename ContainerAllocator>
constexpr uint8_t PSMPVT_<ContainerAllocator>::PSM_STATE_ENABLED;
template<typename ContainerAllocator>
constexpr uint8_t PSMPVT_<ContainerAllocator>::PSM_STATE_ACQUISITION;
template<typename ContainerAllocator>
constexpr uint8_t PSMPVT_<ContainerAllocator>::PSM_STATE_TRACKING;
template<typename ContainerAllocator>
constexpr uint8_t PSMPVT_<ContainerAllocator>::PSM_STATE_POWER_OPTIMIZED_TRACKING;
template<typename ContainerAllocator>
constexpr uint8_t PSMPVT_<ContainerAllocator>::PSM_STATE_INACTIVE;

}  // namespace msg

}  // namespace ublox_ubx_msgs

#endif  // UBLOX_UBX_MSGS__MSG__DETAIL__PSMPVT__STRUCT_HPP_
